Linux mail.vriendennsm.nl 6.1.0-51-amd64 #1 SMP PREEMPT_DYNAMIC Debian 6.1.177-1 (2026-07-16) x86_64
Apache/2.4.68 (Debian)
Server IP : 217.154.75.17 & Your IP : 216.73.216.195
Domains :
Cant Read [ /etc/named.conf ]
User : www-data
Terminal
Auto Root
Create File
Create Folder
Localroot Suggester
Backdoor Destroyer
Readme
/
usr /
bin /
Delete
Unzip
Name
Size
Permission
Date
Action
[
66.89
KB
-rwxr-xr-x
2022-09-20 15:27
aa-enabled
18.23
KB
-rwxr-xr-x
2023-02-14 11:49
aa-exec
18.23
KB
-rwxr-xr-x
2023-02-14 11:49
aa-features-abi
18.23
KB
-rwxr-xr-x
2023-02-14 11:49
ab
58.42
KB
-rwxr-xr-x
2026-06-12 05:08
addpart
30.31
KB
-rwxr-xr-x
2024-11-21 20:01
apropos
51.29
KB
-rwxr-xr-x
2023-03-12 22:23
apt
18.31
KB
-rwxr-xr-x
2023-05-25 14:11
apt-cache
86.38
KB
-rwxr-xr-x
2023-05-25 14:11
apt-cdrom
22.38
KB
-rwxr-xr-x
2023-05-25 14:11
apt-config
26.31
KB
-rwxr-xr-x
2023-05-25 14:11
apt-extracttemplates
22.39
KB
-rwxr-xr-x
2023-05-25 14:11
apt-ftparchive
270.39
KB
-rwxr-xr-x
2023-05-25 14:11
apt-get
50.38
KB
-rwxr-xr-x
2023-05-25 14:11
apt-key
27.32
KB
-rwxr-xr-x
2023-05-25 14:11
apt-listchanges
11.96
KB
-rwxr-xr-x
2021-03-28 11:06
apt-mark
58.38
KB
-rwxr-xr-x
2023-05-25 14:11
apt-sortpkgs
38.32
KB
-rwxr-xr-x
2023-05-25 14:11
arch
42.86
KB
-rwxr-xr-x
2022-09-20 15:27
aria_chk
5.34
MB
-rwxr-xr-x
2026-06-27 11:11
aria_dump_log
5.14
MB
-rwxr-xr-x
2026-06-27 11:11
aria_ftdump
5.15
MB
-rwxr-xr-x
2026-06-27 11:11
aria_pack
5.18
MB
-rwxr-xr-x
2026-06-27 11:11
aria_read_log
5.3
MB
-rwxr-xr-x
2026-06-27 11:11
awk
696.44
KB
-rwxr-xr-x
2023-02-19 13:30
b2sum
58.98
KB
-rwxr-xr-x
2022-09-20 15:27
base32
46.89
KB
-rwxr-xr-x
2022-09-20 15:27
base64
46.89
KB
-rwxr-xr-x
2022-09-20 15:27
basename
42.83
KB
-rwxr-xr-x
2022-09-20 15:27
basenc
54.89
KB
-rwxr-xr-x
2022-09-20 15:27
bash
1.21
MB
-rwxr-xr-x
2026-05-07 20:33
bashbug
6.7
KB
-rwxr-xr-x
2026-05-07 20:33
bunzip2
38.3
KB
-rwxr-xr-x
2022-09-19 02:54
busctl
90.5
KB
-rwxr-xr-x
2026-04-27 19:48
bzcat
38.3
KB
-rwxr-xr-x
2022-09-19 02:54
bzcmp
2.17
KB
-rwxr-xr-x
2022-09-19 02:54
bzdiff
2.17
KB
-rwxr-xr-x
2022-09-19 02:54
bzegrep
3.69
KB
-rwxr-xr-x
2022-09-19 02:54
bzexe
4.78
KB
-rwxr-xr-x
2021-11-27 12:25
bzfgrep
3.69
KB
-rwxr-xr-x
2022-09-19 02:54
bzgrep
3.69
KB
-rwxr-xr-x
2022-09-19 02:54
bzip2
38.3
KB
-rwxr-xr-x
2022-09-19 02:54
bzip2recover
14.23
KB
-rwxr-xr-x
2022-09-19 02:54
bzless
1.27
KB
-rwxr-xr-x
2022-09-19 02:54
bzmore
1.27
KB
-rwxr-xr-x
2022-09-19 02:54
c_rehash
6.76
KB
-rwxr-xr-x
2026-06-06 19:56
captoinfo
90.34
KB
-rwxr-xr-x
2023-05-07 14:33
cat
42.98
KB
-rwxr-xr-x
2022-09-20 15:27
catman
42.77
KB
-rwxr-xr-x
2023-03-12 22:23
certbot
14.79
MB
-rwxr-xr-x
2026-05-10 10:28
cgi-fcgi
18.08
KB
-rwxr-xr-x
2025-05-26 18:18
chage
78.49
KB
-rwxr-sr-x
2025-12-14 14:00
chardet
221
B
-rwxr-xr-x
2022-12-26 14:42
chardetect
221
B
-rwxr-xr-x
2022-12-26 14:42
chattr
14.24
KB
-rwxr-xr-x
2025-06-06 17:12
chcon
67.11
KB
-rwxr-xr-x
2022-09-20 15:27
checkgid
14.23
KB
-rwxr-xr-x
2026-06-12 05:08
chfn
61.2
KB
-rwsr-xr-x
2025-12-14 14:00
chgrp
67.05
KB
-rwxr-xr-x
2022-09-20 15:27
chmod
62.98
KB
-rwxr-xr-x
2022-09-20 15:27
choom
54.31
KB
-rwxr-xr-x
2024-11-21 20:01
chown
71.05
KB
-rwxr-xr-x
2022-09-20 15:27
chrt
66.31
KB
-rwxr-xr-x
2024-11-21 20:01
chsh
51.64
KB
-rwsr-xr-x
2025-12-14 14:00
cksum
139.05
KB
-rwxr-xr-x
2022-09-20 15:27
clear
14.24
KB
-rwxr-xr-x
2023-05-07 14:33
clear_console
14.15
KB
-rwxr-xr-x
2026-05-07 20:33
cloud-id
972
B
-rwxr-xr-x
2026-06-01 19:13
cloud-init
976
B
-rwxr-xr-x
2026-06-01 19:13
cloud-init-per
2.06
KB
-rwxr-xr-x
2022-11-23 21:17
cloud-localds
7.21
KB
-rwxr-xr-x
2022-06-03 10:51
cmp
50.95
KB
-rwxr-xr-x
2023-02-03 19:00
col
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
colcrt
14.31
KB
-rwxr-xr-x
2024-11-21 20:01
colrm
30.31
KB
-rwxr-xr-x
2024-11-21 20:01
column
54.31
KB
-rwxr-xr-x
2024-11-21 20:01
comm
46.92
KB
-rwxr-xr-x
2022-09-20 15:27
compose
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
corelist
15.01
KB
-rwxr-xr-x
2025-08-29 12:09
cp
147.61
KB
-rwxr-xr-x
2022-09-20 15:27
cpan
8.16
KB
-rwxr-xr-x
2025-08-29 12:09
cpan5.36-x86_64-linux-gnu
8.18
KB
-rwxr-xr-x
2025-08-29 12:09
cpio
158.56
KB
-rwxr-xr-x
2022-09-14 19:45
csplit
119.17
KB
-rwxr-xr-x
2022-09-20 15:27
ctstat
26.59
KB
-rwxr-xr-x
2023-05-22 13:19
curl
274.22
KB
-rwxr-xr-x
2026-05-08 14:16
cut
46.98
KB
-rwxr-xr-x
2022-09-20 15:27
cvtsudoers
337.19
KB
-rwxr-xr-x
2026-04-11 12:01
dash
122.7
KB
-rwxr-xr-x
2023-01-05 13:20
date
119.05
KB
-rwxr-xr-x
2022-09-20 15:27
dbilogstrip
1.35
KB
-rwxr-xr-x
2026-06-09 15:14
dbiprof
6.06
KB
-rwxr-xr-x
2026-06-09 15:14
dbiproxy
5.27
KB
-rwxr-xr-x
2026-06-09 15:14
dbus-cleanup-sockets
14.22
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-daemon
238.56
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-monitor
26.23
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-run-session
14.23
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-send
30.22
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-update-activation-environment
14.22
KB
-rwxr-xr-x
2023-09-16 10:03
dbus-uuidgen
14.22
KB
-rwxr-xr-x
2023-09-16 10:03
dd
87.15
KB
-rwxr-xr-x
2022-09-20 15:27
deb-systemd-helper
23.79
KB
-rwxr-xr-x
2022-07-13 19:55
deb-systemd-invoke
6.09
KB
-rwxr-xr-x
2025-08-20 18:56
debconf
2.79
KB
-rwxr-xr-x
2023-01-08 21:50
debconf-apt-progress
11.27
KB
-rwxr-xr-x
2023-01-08 21:50
debconf-communicate
608
B
-rwxr-xr-x
2023-01-08 21:50
debconf-copydb
1.68
KB
-rwxr-xr-x
2023-01-08 21:50
debconf-escape
647
B
-rwxr-xr-x
2023-01-08 21:50
debconf-set-selections
2.92
KB
-rwxr-xr-x
2023-01-08 21:50
debconf-show
1.78
KB
-rwxr-xr-x
2023-01-08 21:50
debianbts
217
B
-rwxr-xr-x
2022-12-08 11:34
decodemail
30.7
KB
-rwxr-xr-x
2023-03-03 16:00
delpart
30.31
KB
-rwxr-xr-x
2024-11-21 20:01
devdump
180.17
KB
-rwxr-xr-x
2022-06-24 14:56
df
99.8
KB
-rwxr-xr-x
2022-09-20 15:27
dh_bash-completion
4.31
KB
-rwxr-xr-x
2021-08-28 15:26
dh_installxmlcatalogs
9.22
KB
-rwxr-xr-x
2019-02-27 00:18
dh_perl_dbi
1.17
KB
-rwxr-xr-x
2026-06-09 15:14
dh_perl_openssl
1.53
KB
-rwxr-xr-x
2022-05-01 18:31
diff
151.58
KB
-rwxr-xr-x
2023-02-03 19:00
diff3
67.14
KB
-rwxr-xr-x
2023-02-03 19:00
dir
147.8
KB
-rwxr-xr-x
2022-09-20 15:27
dircolors
50.92
KB
-rwxr-xr-x
2022-09-20 15:27
dirmngr
586.13
KB
-rwxr-xr-x
2026-01-01 14:54
dirmngr-client
106.87
KB
-rwxr-xr-x
2026-01-01 14:54
dirname
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
dirsplit
16.74
KB
-rwxr-xr-x
2006-11-25 23:13
dmesg
86.58
KB
-rwxr-xr-x
2024-11-21 20:01
dnsdomainname
22.15
KB
-rwxr-xr-x
2022-12-19 13:33
domainname
22.15
KB
-rwxr-xr-x
2022-12-19 13:33
dotlock
15.07
KB
-rwxr-sr-x
2023-03-03 16:00
dotlock.mailutils
15.07
KB
-rwxr-sr-x
2023-03-03 16:00
dpkg
310.64
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-deb
166.52
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-divert
154.55
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-maintscript-helper
20.71
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-query
158.58
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-realpath
4.09
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-split
126.48
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-statoverride
62.33
KB
-rwxr-xr-x
2026-03-07 12:15
dpkg-trigger
86.48
KB
-rwxr-xr-x
2026-03-07 12:15
du
171.33
KB
-rwxr-xr-x
2022-09-20 15:27
ec2metadata
8.38
KB
-rwxr-xr-x
2022-06-03 10:51
echo
42.83
KB
-rwxr-xr-x
2022-09-20 15:27
edit
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
editor
280.74
KB
-rwxr-xr-x
2024-05-06 06:10
egrep
41
B
-rwxr-xr-x
2023-01-24 14:43
eject
82.16
KB
-rwxr-xr-x
2024-11-21 20:01
enc2xs
40.96
KB
-rwxr-xr-x
2025-08-29 12:09
encguess
3
KB
-rwxr-xr-x
2025-08-29 12:09
env
47.4
KB
-rwxr-xr-x
2022-09-20 15:27
envsubst
34.31
KB
-rwxr-xr-x
2023-02-26 15:20
eqn
205.42
KB
-rwxr-xr-x
2023-03-07 09:38
ex
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
exonpairs
123.43
KB
-rwxr-xr-x
2020-12-22 13:24
expand
42.92
KB
-rwxr-xr-x
2022-09-20 15:27
expiry
30.45
KB
-rwxr-sr-x
2025-12-14 14:00
expr
115.05
KB
-rwxr-xr-x
2022-09-20 15:27
factor
83.2
KB
-rwxr-xr-x
2022-09-20 15:27
faillog
22.53
KB
-rwxr-xr-x
2025-12-14 14:00
fallocate
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
false
34.83
KB
-rwxr-xr-x
2022-09-20 15:27
fathom
151.24
KB
-rwxr-xr-x
2020-12-22 13:24
fcgistarter
14.23
KB
-rwxr-xr-x
2026-06-12 05:08
fgrep
41
B
-rwxr-xr-x
2023-01-24 14:43
filan
96.02
KB
-rwxr-xr-x
2022-11-06 08:15
file
26.48
KB
-rwxr-xr-x
2023-01-28 18:17
fincore
34.36
KB
-rwxr-xr-x
2024-11-21 20:01
find
219.58
KB
-rwxr-xr-x
2023-01-08 18:07
findmnt
83.59
KB
-rwxr-xr-x
2024-11-21 20:01
flock
34.39
KB
-rwxr-xr-x
2024-11-21 20:01
fmt
46.89
KB
-rwxr-xr-x
2022-09-20 15:27
fold
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
forge
135.21
KB
-rwxr-xr-x
2020-12-22 13:24
free
26.3
KB
-rwxr-xr-x
2022-12-19 06:06
frm
27.23
KB
-rwxr-xr-x
2023-03-03 16:00
frm.mailutils
27.23
KB
-rwxr-xr-x
2023-03-03 16:00
from
22.78
KB
-rwxr-xr-x
2023-03-03 16:00
from.mailutils
22.78
KB
-rwxr-xr-x
2023-03-03 16:00
funzip
22.46
KB
-rwxr-xr-x
2026-08-16 13:50
fuser
39.83
KB
-rwxr-xr-x
2022-12-13 05:27
galera_new_cluster
930
B
-rwxr-xr-x
2026-06-27 11:11
galera_recovery
3.29
KB
-rwxr-xr-x
2026-06-27 11:11
gawk
696.44
KB
-rwxr-xr-x
2023-02-19 13:30
gawkbug
6.54
KB
-rwxr-xr-x
2023-02-19 13:30
genisoimage
631.17
KB
-rwxr-xr-x
2022-06-24 14:56
geqn
205.42
KB
-rwxr-xr-x
2023-03-07 09:38
getconf
26.5
KB
-rwxr-xr-x
2026-04-27 20:14
geteltorito
6.06
KB
-rwxr-xr-x
2022-06-24 14:56
getent
35.47
KB
-rwxr-xr-x
2026-04-27 20:14
getopt
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
gettext
34.31
KB
-rwxr-xr-x
2023-02-26 15:20
gettext.sh
5.07
KB
-rwxr-xr-x
2023-02-26 15:20
gpasswd
86.42
KB
-rwsr-xr-x
2025-12-14 14:00
gpg
1.06
MB
-rwxr-xr-x
2026-01-01 14:54
gpg-agent
425.22
KB
-rwxr-xr-x
2026-01-01 14:54
gpg-connect-agent
154.96
KB
-rwxr-xr-x
2026-01-01 14:54
gpg-wks-server
203
KB
-rwxr-xr-x
2026-01-01 14:54
gpg-zip
3.43
KB
-rwxr-xr-x
2026-01-01 14:54
gpgcompose
910.27
KB
-rwxr-xr-x
2026-01-01 14:54
gpgconf
174.73
KB
-rwxr-xr-x
2026-01-01 14:54
gpgparsemail
34.3
KB
-rwxr-xr-x
2026-01-01 14:54
gpgsm
527.66
KB
-rwxr-xr-x
2026-01-01 14:54
gpgsplit
74.56
KB
-rwxr-xr-x
2026-01-01 14:54
gpgtar
147.52
KB
-rwxr-xr-x
2026-01-01 14:54
gpgv
463
KB
-rwxr-xr-x
2026-01-01 14:54
gpic
220.27
KB
-rwxr-xr-x
2023-03-07 09:38
grep
198.39
KB
-rwxr-xr-x
2023-01-24 14:43
groff
125.45
KB
-rwxr-xr-x
2023-03-07 09:38
grog
2.71
KB
-rwxr-xr-x
2023-03-07 09:38
grops
185.86
KB
-rwxr-xr-x
2023-03-07 09:38
grotty
137.48
KB
-rwxr-xr-x
2023-03-07 09:38
groups
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
growpart
29.19
KB
-rwxr-xr-x
2022-06-03 10:51
grub-editenv
374.23
KB
-rwxr-xr-x
2026-04-01 20:03
grub-file
814.7
KB
-rwxr-xr-x
2026-04-01 20:03
grub-fstest
936.38
KB
-rwxr-xr-x
2026-04-01 20:03
grub-glue-efi
245.07
KB
-rwxr-xr-x
2026-04-01 20:03
grub-kbdcomp
1.64
KB
-rwxr-xr-x
2026-04-01 20:03
grub-menulst2cfg
229.12
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkfont
273.73
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkimage
354.26
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mklayout
253.35
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mknetdir
411.02
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkpasswd-pbkdf2
257.41
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkrelpath
244.76
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkrescue
993.12
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mkstandalone
487.41
KB
-rwxr-xr-x
2026-04-01 20:03
grub-mount
759.3
KB
-rwxr-xr-x
2026-04-01 20:03
grub-render-label
827.26
KB
-rwxr-xr-x
2026-04-01 20:03
grub-script-check
272.88
KB
-rwxr-xr-x
2026-04-01 20:03
grub-syslinux2cfg
775.77
KB
-rwxr-xr-x
2026-04-01 20:03
gtbl
146.43
KB
-rwxr-xr-x
2023-03-07 09:38
gunzip
2.29
KB
-rwxr-xr-x
2022-04-10 02:22
gzexe
6.3
KB
-rwxr-xr-x
2022-04-10 02:22
gzip
95.84
KB
-rwxr-xr-x
2022-04-10 02:22
h2ph
28.54
KB
-rwxr-xr-x
2025-08-29 12:09
h2xs
59.51
KB
-rwxr-xr-x
2025-08-29 12:09
hardlink
50.39
KB
-rwxr-xr-x
2024-11-21 20:01
hd
58.32
KB
-rwxr-xr-x
2024-11-21 20:01
head
46.95
KB
-rwxr-xr-x
2022-09-20 15:27
helpztags
2.46
KB
-rwxr-xr-x
2025-02-16 05:23
hexdump
58.32
KB
-rwxr-xr-x
2024-11-21 20:01
hmm-assembler.pl
11.08
KB
-rwxr-xr-x
2013-11-30 07:54
hmm-info
118.62
KB
-rwxr-xr-x
2020-12-22 13:24
host
114.7
KB
-rwxr-xr-x
2026-07-31 21:11
hostid
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
hostname
22.15
KB
-rwxr-xr-x
2022-12-19 13:33
hostnamectl
30.38
KB
-rwxr-xr-x
2026-04-27 19:48
htcacheclean
34.24
KB
-rwxr-xr-x
2026-06-12 05:08
htdbm
26.23
KB
-rwxr-xr-x
2026-06-12 05:08
htdigest
14.23
KB
-rwxr-xr-x
2026-06-12 05:08
html2text
214.17
KB
-rwxr-xr-x
2020-06-23 20:20
htpasswd
26.23
KB
-rwxr-xr-x
2026-06-12 05:08
i386
26.58
KB
-rwxr-xr-x
2024-11-21 20:01
iconv
63.13
KB
-rwxr-xr-x
2026-04-27 20:14
id
47.02
KB
-rwxr-xr-x
2022-09-20 15:27
infocmp
62.31
KB
-rwxr-xr-x
2023-05-07 14:33
infotocap
90.34
KB
-rwxr-xr-x
2023-05-07 14:33
innochecksum
4.51
MB
-rwxr-xr-x
2026-06-27 11:11
innotop
445.44
KB
-rwxr-xr-x
2026-06-27 11:11
install
155.8
KB
-rwxr-xr-x
2022-09-20 15:27
instmodsh
4.27
KB
-rwxr-xr-x
2025-08-29 12:09
ionice
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
ip
674.82
KB
-rwxr-xr-x
2023-05-22 13:19
ipcmk
34.38
KB
-rwxr-xr-x
2024-11-21 20:01
ipcrm
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
ipcs
74.31
KB
-rwxr-xr-x
2024-11-21 20:01
iptables-xml
88.98
KB
-rwxr-xr-x
2023-01-16 13:44
ischroot
14.32
KB
-rwxr-xr-x
2023-07-28 23:46
isodump
180.17
KB
-rwxr-xr-x
2022-06-24 14:56
isoinfo
343.42
KB
-rwxr-xr-x
2022-06-24 14:56
isovfy
184.14
KB
-rwxr-xr-x
2022-06-24 14:56
join
54.98
KB
-rwxr-xr-x
2022-09-20 15:27
journalctl
74.64
KB
-rwxr-xr-x
2026-04-27 19:48
json-patch-jsondiff
1004
B
-rwxr-xr-x
2021-09-29 10:31
json_pp
4.88
KB
-rwxr-xr-x
2025-08-29 12:09
json_xs
6.85
KB
-rwxr-xr-x
2025-09-08 20:30
jsondiff
1004
B
-rwxr-xr-x
2021-09-29 10:31
jsonpatch
3.77
KB
-rwxr-xr-x
2021-09-29 10:31
jsonpointer
1.79
KB
-rwxr-xr-x
2022-09-23 09:59
jsonschema
213
B
-rwxr-xr-x
2023-01-20 10:53
kbxutil
162.77
KB
-rwxr-xr-x
2026-01-01 14:54
kernel-install
12.75
KB
-rwxr-xr-x
2026-04-27 19:48
kill
22.3
KB
-rwxr-xr-x
2022-12-19 06:06
killall
31.95
KB
-rwxr-xr-x
2022-12-13 05:27
kmod
174.27
KB
-rwxr-xr-x
2022-12-10 00:02
last
50.31
KB
-rwxr-xr-x
2024-11-21 20:01
lastb
50.31
KB
-rwxr-xr-x
2024-11-21 20:01
lastlog
31.75
KB
-rwxr-xr-x
2025-12-14 14:00
lcf
7.6
KB
-rwxr-xr-x
2024-12-20 07:39
ld.so
209.96
KB
-rwxr-xr-x
2026-04-27 20:14
ldd
5.28
KB
-rwxr-xr-x
2026-04-27 20:14
less
194.3
KB
-rwxr-xr-x
2024-05-02 18:30
lessecho
14.24
KB
-rwxr-xr-x
2024-05-02 18:30
lessfile
8.83
KB
-rwxr-xr-x
2024-05-02 18:30
lesskey
23.63
KB
-rwxr-xr-x
2024-05-02 18:30
lesspipe
8.83
KB
-rwxr-xr-x
2024-05-02 18:30
lexgrog
107.48
KB
-rwxr-xr-x
2023-03-12 22:23
lft
2.43
KB
-rwxr-xr-x
2023-02-25 12:24
lft.db
2.43
KB
-rwxr-xr-x
2023-02-25 12:24
libnetcfg
15.41
KB
-rwxr-xr-x
2025-08-29 12:09
link
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
linux-check-removal
4.6
KB
-rwxr-xr-x
2025-05-25 15:54
linux-run-hooks
3.46
KB
-rwxr-xr-x
2026-06-08 20:53
linux-update-symlinks
6.38
KB
-rwxr-xr-x
2025-05-25 15:54
linux-version
2.67
KB
-rwxr-xr-x
2025-05-25 15:54
linux32
26.58
KB
-rwxr-xr-x
2024-11-21 20:01
linux64
26.58
KB
-rwxr-xr-x
2024-11-21 20:01
ln
71.12
KB
-rwxr-xr-x
2022-09-20 15:27
lnstat
26.59
KB
-rwxr-xr-x
2023-05-22 13:19
locale
46.16
KB
-rwxr-xr-x
2026-04-27 20:14
localectl
26.38
KB
-rwxr-xr-x
2026-04-27 19:48
localedef
291.91
KB
-rwxr-xr-x
2026-04-27 20:14
logger
54.9
KB
-rwxr-xr-x
2024-11-21 20:01
login
51.78
KB
-rwxr-xr-x
2025-12-14 14:00
loginctl
58.48
KB
-rwxr-xr-x
2026-04-27 19:48
logname
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
logresolve
14.24
KB
-rwxr-xr-x
2026-06-12 05:08
look
18.31
KB
-rwxr-xr-x
2024-11-21 20:01
ls
147.8
KB
-rwxr-xr-x
2022-09-20 15:27
lsattr
14.24
KB
-rwxr-xr-x
2025-06-06 17:12
lsb_release
2.59
KB
-rwxr-xr-x
2022-09-26 20:06
lsblk
202.31
KB
-rwxr-xr-x
2024-11-21 20:01
lscpu
126.31
KB
-rwxr-xr-x
2024-11-21 20:01
lsfd
120.3
KB
-rwxr-xr-x
2024-11-21 20:01
lsinitramfs
735
B
-rwxr-xr-x
2025-03-02 16:09
lsipc
98.31
KB
-rwxr-xr-x
2024-11-21 20:01
lsirq
34.48
KB
-rwxr-xr-x
2024-11-21 20:01
lslocks
70.7
KB
-rwxr-xr-x
2024-11-21 20:01
lslogins
94.31
KB
-rwxr-xr-x
2024-11-21 20:01
lsmem
66.31
KB
-rwxr-xr-x
2024-11-21 20:01
lsmod
174.27
KB
-rwxr-xr-x
2022-12-10 00:02
lsns
82.31
KB
-rwxr-xr-x
2024-11-21 20:01
lsof
175.61
KB
-rwxr-xr-x
2022-04-28 04:08
lspci
104.04
KB
-rwxr-xr-x
2023-01-17 23:50
lspgpot
1.06
KB
-rwxr-xr-x
2017-08-28 10:22
lynx
1.86
MB
-rwxr-xr-x
2023-01-15 14:21
lzcat
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
lzcmp
7.25
KB
-rwxr-xr-x
2026-06-26 13:13
lzdiff
7.25
KB
-rwxr-xr-x
2026-06-26 13:13
lzegrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
lzfgrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
lzgrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
lzless
1.77
KB
-rwxr-xr-x
2026-06-26 13:13
lzma
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
lzmainfo
14.3
KB
-rwxr-xr-x
2026-06-26 13:13
lzmore
2.14
KB
-rwxr-xr-x
2026-06-26 13:13
mail
225.28
KB
-rwxr-xr-x
2023-03-03 16:00
mail.mailutils
225.28
KB
-rwxr-xr-x
2023-03-03 16:00
mailq
30.38
KB
-rwxr-xr-x
2024-03-06 15:10
mailx
225.28
KB
-rwxr-xr-x
2023-03-03 16:00
man
121.36
KB
-rwxr-xr-x
2023-03-12 22:23
man-recode
35.38
KB
-rwxr-xr-x
2023-03-12 22:23
mandb
147.61
KB
-rwxr-xr-x
2023-03-12 22:23
manpath
34.78
KB
-rwxr-xr-x
2023-03-12 22:23
mariadb
4.98
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-access
109.31
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-admin
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-analyze
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-binlog
5.02
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-check
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-conv
4.5
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-convert-table-format
4.12
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-dump
4.85
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-dumpslow
8.05
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-find-rows
3.21
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-fix-extensions
1.22
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-hotcopy
34.53
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-import
4.75
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-install-db
22.13
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-optimize
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-plugin
4.48
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-repair
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-report
49.02
KB
-rwxr-xr-x
2025-02-10 17:26
mariadb-secure-installation
13.48
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-service-convert
2.45
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-setpermission
17.56
KB
-rwxr-xr-x
2026-06-27 11:11
mariadb-show
4.75
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-slap
4.77
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-tzinfo-to-sql
4.48
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-upgrade
4.91
MB
-rwxr-xr-x
2026-06-27 11:11
mariadb-waitpid
4.46
MB
-rwxr-xr-x
2026-06-27 11:11
mariadbcheck
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mariadbd-multi
26.69
KB
-rwxr-xr-x
2026-06-27 11:11
mariadbd-safe
30.42
KB
-rwxr-xr-x
2026-06-27 11:11
mariadbd-safe-helper
4.44
MB
-rwxr-xr-x
2026-06-27 11:11
markdown-it
220
B
-rwxr-xr-x
2023-03-31 10:50
mawk
154.66
KB
-rwxr-xr-x
2022-06-17 15:35
mc
1.02
MB
-rwxr-xr-x
2023-02-14 12:56
mcdiff
1.02
MB
-rwxr-xr-x
2023-02-14 12:56
mcedit
1.02
MB
-rwxr-xr-x
2023-02-14 12:56
mcookie
34.38
KB
-rwxr-xr-x
2024-11-21 20:01
mcview
1.02
MB
-rwxr-xr-x
2023-02-14 12:56
md5sum
50.95
KB
-rwxr-xr-x
2022-09-20 15:27
md5sum.textutils
50.95
KB
-rwxr-xr-x
2022-09-20 15:27
mesg
18.3
KB
-rwxr-xr-x
2024-11-21 20:01
messages
14.6
KB
-rwxr-xr-x
2023-03-03 16:00
messages.mailutils
14.6
KB
-rwxr-xr-x
2023-03-03 16:00
migrate-pubring-from-classic-gpg
2.99
KB
-rwxr-xr-x
2025-12-31 17:32
mimeview
19.28
KB
-rwxr-xr-x
2023-03-03 16:00
mkdir
95.27
KB
-rwxr-xr-x
2022-09-20 15:27
mkfifo
67.17
KB
-rwxr-xr-x
2022-09-20 15:27
mkisofs
631.17
KB
-rwxr-xr-x
2022-06-24 14:56
mknod
71.2
KB
-rwxr-xr-x
2022-09-20 15:27
mksquashfs
263.9
KB
-rwxr-xr-x
2022-03-27 16:50
mktemp
42.92
KB
-rwxr-xr-x
2022-09-20 15:27
mkzftree
30.84
KB
-rwxr-xr-x
2022-06-24 14:56
mokutil
60.27
KB
-rwxr-xr-x
2022-06-15 13:30
more
58.31
KB
-rwxr-xr-x
2024-11-21 20:01
mount
58.3
KB
-rwsr-xr-x
2024-11-21 20:01
mount-image-callback
13.86
KB
-rwxr-xr-x
2022-06-03 10:51
mountpoint
18.3
KB
-rwxr-xr-x
2024-11-21 20:01
movemail
40.19
KB
-rwxr-xr-x
2023-03-03 16:00
movemail.mailutils
40.19
KB
-rwxr-xr-x
2023-03-03 16:00
msql2mysql
1.41
KB
-rwxr-xr-x
2026-06-27 11:11
mt
83.38
KB
-rwxr-xr-x
2022-09-14 19:45
mt-gnu
83.38
KB
-rwxr-xr-x
2022-09-14 19:45
mv
139.62
KB
-rwxr-xr-x
2022-09-20 15:27
my_print_defaults
4.47
MB
-rwxr-xr-x
2026-06-27 11:11
myisam_ftdump
4.75
MB
-rwxr-xr-x
2026-06-27 11:11
myisamchk
4.87
MB
-rwxr-xr-x
2026-06-27 11:11
myisamlog
4.73
MB
-rwxr-xr-x
2026-06-27 11:11
myisampack
4.77
MB
-rwxr-xr-x
2026-06-27 11:11
mysql
4.98
MB
-rwxr-xr-x
2026-06-27 11:11
mysql_convert_table_format
4.12
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_find_rows
3.21
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_fix_extensions
1.22
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_install_db
22.13
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_plugin
4.48
MB
-rwxr-xr-x
2026-06-27 11:11
mysql_secure_installation
13.48
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_setpermission
17.56
KB
-rwxr-xr-x
2026-06-27 11:11
mysql_tzinfo_to_sql
4.48
MB
-rwxr-xr-x
2026-06-27 11:11
mysql_upgrade
4.91
MB
-rwxr-xr-x
2026-06-27 11:11
mysql_waitpid
4.46
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlaccess
109.31
KB
-rwxr-xr-x
2026-06-27 11:11
mysqladmin
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlanalyze
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlbinlog
5.02
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlcheck
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mysqld_multi
26.69
KB
-rwxr-xr-x
2026-06-27 11:11
mysqld_safe
30.42
KB
-rwxr-xr-x
2026-06-27 11:11
mysqld_safe_helper
4.44
MB
-rwxr-xr-x
2026-06-27 11:11
mysqldump
4.85
MB
-rwxr-xr-x
2026-06-27 11:11
mysqldumpslow
8.05
KB
-rwxr-xr-x
2026-06-27 11:11
mysqlhotcopy
34.53
KB
-rwxr-xr-x
2026-06-27 11:11
mysqlimport
4.75
MB
-rwxr-xr-x
2026-06-27 11:11
mysqloptimize
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlrepair
4.76
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlreport
49.02
KB
-rwxr-xr-x
2025-02-10 17:26
mysqlshow
4.75
MB
-rwxr-xr-x
2026-06-27 11:11
mysqlslap
4.77
MB
-rwxr-xr-x
2026-06-27 11:11
mytop
72.03
KB
-rwxr-xr-x
2026-06-27 11:11
namei
34.31
KB
-rwxr-xr-x
2024-11-21 20:01
nano
280.74
KB
-rwxr-xr-x
2024-05-06 06:10
nawk
696.44
KB
-rwxr-xr-x
2023-02-19 13:30
neqn
913
B
-rwxr-xr-x
2023-03-07 09:38
netstat
151.66
KB
-rwxr-xr-x
2025-05-26 19:27
networkctl
106.38
KB
-rwxr-xr-x
2026-04-27 19:48
newaliases
30.38
KB
-rwxr-xr-x
2024-03-06 15:10
newgrp
47.75
KB
-rwsr-xr-x
2025-12-14 14:00
ngettext
34.31
KB
-rwxr-xr-x
2023-02-26 15:20
nice
42.86
KB
-rwxr-xr-x
2022-09-20 15:27
nisdomainname
22.15
KB
-rwxr-xr-x
2022-12-19 13:33
nl
111.11
KB
-rwxr-xr-x
2022-09-20 15:27
nohup
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
normalizer
244
B
-rwxr-xr-x
2022-11-27 08:00
nproc
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
nroff
3.22
KB
-rwxr-xr-x
2023-03-07 09:38
nsenter
34.54
KB
-rwxr-xr-x
2024-11-21 20:01
nstat
104.45
KB
-rwxr-xr-x
2023-05-22 13:19
numfmt
67.02
KB
-rwxr-xr-x
2022-09-20 15:27
od
79.02
KB
-rwxr-xr-x
2022-09-20 15:27
open
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
openssl
953.26
KB
-rwxr-xr-x
2026-06-06 19:56
pager
194.3
KB
-rwxr-xr-x
2024-05-02 18:30
partx
118.31
KB
-rwxr-xr-x
2024-11-21 20:01
passwd
66.65
KB
-rwsr-xr-x
2025-12-14 14:00
paste
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
patch-hmm.pl
580
B
-rwxr-xr-x
2013-11-30 07:54
pathchk
42.86
KB
-rwxr-xr-x
2022-09-20 15:27
pdb3
62.4
KB
-rwxr-xr-x
2026-05-12 05:17
pdb3.11
62.4
KB
-rwxr-xr-x
2026-05-12 05:17
peekfd
14.5
KB
-rwxr-xr-x
2022-12-13 05:27
perl
3.63
MB
-rwxr-xr-x
2025-08-29 12:09
perl5.36-x86_64-linux-gnu
14.41
KB
-rwxr-xr-x
2025-08-29 12:09
perl5.36.0
3.63
MB
-rwxr-xr-x
2025-08-29 12:09
perlbug
44.12
KB
-rwxr-xr-x
2025-08-29 12:09
perldoc
125
B
-rwxr-xr-x
2025-08-16 18:03
perlivp
10.61
KB
-rwxr-xr-x
2025-08-29 12:09
perlthanks
44.12
KB
-rwxr-xr-x
2025-08-29 12:09
perror
4.66
MB
-rwxr-xr-x
2026-06-27 11:11
pgrep
34.42
KB
-rwxr-xr-x
2022-12-19 06:06
phar
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar.default
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar.phar
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar.phar.default
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar.phar8.1
14.89
KB
-rwxr-xr-x
2026-07-03 10:33
phar.phar8.3
14.88
KB
-rwxr-xr-x
2026-07-08 19:13
phar.phar8.4
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar8.1
14.89
KB
-rwxr-xr-x
2026-07-03 10:33
phar8.1.phar
14.89
KB
-rwxr-xr-x
2026-07-03 10:33
phar8.3
14.88
KB
-rwxr-xr-x
2026-07-08 19:13
phar8.3.phar
14.88
KB
-rwxr-xr-x
2026-07-08 19:13
phar8.4
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
phar8.4.phar
14.88
KB
-rwxr-xr-x
2026-07-03 10:04
php
5.3
MB
-rwxr-xr-x
2026-07-03 10:33
php.default
5.73
MB
-rwxr-xr-x
2026-07-03 10:04
php8.1
5.3
MB
-rwxr-xr-x
2026-07-03 10:33
php8.3
5.5
MB
-rwxr-xr-x
2026-07-08 19:13
php8.4
5.73
MB
-rwxr-xr-x
2026-07-03 10:04
pic
220.27
KB
-rwxr-xr-x
2023-03-07 09:38
pico
280.74
KB
-rwxr-xr-x
2024-05-06 06:10
piconv
8.16
KB
-rwxr-xr-x
2025-08-29 12:09
pidof
26.31
KB
-rwxr-xr-x
2023-04-03 06:25
pidwait
34.42
KB
-rwxr-xr-x
2022-12-19 06:06
pinentry
70.57
KB
-rwxr-xr-x
2022-10-18 14:52
pinentry-curses
70.57
KB
-rwxr-xr-x
2022-10-18 14:52
ping
88.45
KB
-rwxr-xr-x
2024-09-24 17:00
ping4
88.45
KB
-rwxr-xr-x
2024-09-24 17:00
ping6
88.45
KB
-rwxr-xr-x
2024-09-24 17:00
pinky
47.05
KB
-rwxr-xr-x
2022-09-20 15:27
pkaction
18.23
KB
-rwxr-xr-x
2023-01-31 22:05
pkcheck
22.3
KB
-rwxr-xr-x
2023-01-31 22:05
pkill
34.42
KB
-rwxr-xr-x
2022-12-19 06:06
pkttyagent
18.23
KB
-rwxr-xr-x
2023-01-31 22:05
pl2pm
4.43
KB
-rwxr-xr-x
2025-08-29 12:09
pldd
22.69
KB
-rwxr-xr-x
2026-04-27 20:14
pmap
34.34
KB
-rwxr-xr-x
2022-12-19 06:06
pod2html
4.04
KB
-rwxr-xr-x
2025-08-29 12:09
pod2man
14.68
KB
-rwxr-xr-x
2025-08-29 12:09
pod2text
10.55
KB
-rwxr-xr-x
2025-08-29 12:09
pod2usage
4.01
KB
-rwxr-xr-x
2025-08-29 12:09
podchecker
3.57
KB
-rwxr-xr-x
2025-08-29 12:09
pr
79.11
KB
-rwxr-xr-x
2022-09-20 15:27
preconv
66.43
KB
-rwxr-xr-x
2023-03-07 09:38
print
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
printenv
34.83
KB
-rwxr-xr-x
2022-09-20 15:27
printf
62.92
KB
-rwxr-xr-x
2022-09-20 15:27
prlimit
38.83
KB
-rwxr-xr-x
2024-11-21 20:01
procan
79.91
KB
-rwxr-xr-x
2022-11-06 08:15
prove
13.34
KB
-rwxr-xr-x
2025-08-29 12:09
prtstat
18.57
KB
-rwxr-xr-x
2022-12-13 05:27
ps
142.93
KB
-rwxr-xr-x
2022-12-19 06:06
pslog
14.45
KB
-rwxr-xr-x
2022-12-13 05:27
pstree
35.78
KB
-rwxr-xr-x
2022-12-13 05:27
pstree.x11
35.78
KB
-rwxr-xr-x
2022-12-13 05:27
ptar
3.48
KB
-rwxr-xr-x
2025-08-29 12:09
ptardiff
2.58
KB
-rwxr-xr-x
2025-08-29 12:09
ptargrep
4.29
KB
-rwxr-xr-x
2025-08-29 12:09
ptx
135.23
KB
-rwxr-xr-x
2022-09-20 15:27
pv
63.98
KB
-rwxr-xr-x
2022-04-12 00:55
pwd
42.92
KB
-rwxr-xr-x
2022-09-20 15:27
pwdx
14.3
KB
-rwxr-xr-x
2022-12-19 06:06
py3clean
7.63
KB
-rwxr-xr-x
2023-04-09 10:22
py3compile
13
KB
-rwxr-xr-x
2023-04-09 10:22
py3versions
12.52
KB
-rwxr-xr-x
2023-04-09 10:22
pydoc3
79
B
-rwxr-xr-x
2026-05-12 05:17
pydoc3.11
79
B
-rwxr-xr-x
2026-05-12 05:17
pygettext3
23.67
KB
-rwxr-xr-x
2023-02-07 13:37
pygettext3.11
23.67
KB
-rwxr-xr-x
2023-02-07 13:37
pygmentize
970
B
-rwxr-xr-x
2023-01-07 09:12
pyserial-miniterm
975
B
-rwxr-xr-x
2022-09-26 15:04
pyserial-ports
969
B
-rwxr-xr-x
2022-09-26 15:04
python3
6.52
MB
-rwxr-xr-x
2026-05-12 05:17
python3.11
6.52
MB
-rwxr-xr-x
2026-05-12 05:17
pzstd
742.38
KB
-rwxr-xr-x
2023-03-18 20:58
qemu-img
2.19
MB
-rwxr-xr-x
2026-05-25 20:44
qemu-io
2.14
MB
-rwxr-xr-x
2026-05-25 20:44
qemu-nbd
2.33
MB
-rwxr-xr-x
2026-05-25 20:44
qrencode
38.56
KB
-rwxr-xr-x
2020-12-22 05:31
querybts
10.64
KB
-rwxr-xr-x
2023-04-29 06:38
rbash
1.21
MB
-rwxr-xr-x
2026-05-07 20:33
rdma
180.6
KB
-rwxr-xr-x
2023-05-22 13:19
readlink
50.89
KB
-rwxr-xr-x
2022-09-20 15:27
readmsg
35.84
KB
-rwxr-xr-x
2023-03-03 16:00
readmsg.mailutils
35.84
KB
-rwxr-xr-x
2023-03-03 16:00
realpath
50.92
KB
-rwxr-xr-x
2022-09-20 15:27
rename.ul
22.3
KB
-rwxr-xr-x
2024-11-21 20:01
renice
14.3
KB
-rwxr-xr-x
2024-11-21 20:01
replace
4.45
MB
-rwxr-xr-x
2026-06-27 11:11
reportbug
110.11
KB
-rwxr-xr-x
2023-04-29 06:38
reset
30.24
KB
-rwxr-xr-x
2023-05-07 14:33
resize-part-image
4.23
KB
-rwxr-xr-x
2022-06-03 10:51
resizepart
70.31
KB
-rwxr-xr-x
2024-11-21 20:01
resolve_stack_dump
4.47
MB
-rwxr-xr-x
2026-06-27 11:11
resolvectl
146.53
KB
-rwxr-xr-x
2026-04-27 19:48
resolveip
4.46
MB
-rwxr-xr-x
2026-06-27 11:11
rev
14.3
KB
-rwxr-xr-x
2024-11-21 20:01
rgrep
30
B
-rwxr-xr-x
2020-01-29 12:09
rm
71.05
KB
-rwxr-xr-x
2022-09-20 15:27
rmail
18.3
KB
-rwxr-xr-x
2024-03-06 15:10
rmdir
54.92
KB
-rwxr-xr-x
2022-09-20 15:27
rnano
280.74
KB
-rwxr-xr-x
2024-05-06 06:10
rotatelogs
26.31
KB
-rwxr-xr-x
2026-06-12 05:08
routel
1.62
KB
-rwxr-xr-x
2023-05-22 13:19
rrsync
12.34
KB
-rwxr-xr-x
2026-05-24 21:23
rsync
514.35
KB
-rwxr-xr-x
2026-05-24 21:23
rsync-ssl
5.02
KB
-rwxr-xr-x
2026-05-24 21:23
rtstat
26.59
KB
-rwxr-xr-x
2023-05-22 13:19
run-mailcap
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
run-parts
26.91
KB
-rwxr-xr-x
2023-07-28 23:46
runcon
42.95
KB
-rwxr-xr-x
2022-09-20 15:27
rview
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
rvim
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
savelog
10.24
KB
-rwxr-xr-x
2023-07-28 23:46
scp
266.63
KB
-rwxr-xr-x
2026-05-05 10:26
screen
471.09
KB
-rwxr-xr-x
2023-01-09 03:56
script
70.3
KB
-rwxr-xr-x
2024-11-21 20:01
scriptlive
54.3
KB
-rwxr-xr-x
2024-11-21 20:01
scriptreplay
46.3
KB
-rwxr-xr-x
2024-11-21 20:01
sdiff
55.08
KB
-rwxr-xr-x
2023-02-03 19:00
sed
123.46
KB
-rwxr-xr-x
2026-04-21 07:50
see
18.06
KB
-rwxr-xr-x
2021-11-29 13:07
select-editor
2.39
KB
-rwxr-xr-x
2023-01-14 16:28
sensible-browser
1.26
KB
-rwxr-xr-x
2023-01-14 16:28
sensible-editor
1.24
KB
-rwxr-xr-x
2023-01-14 16:28
sensible-pager
565
B
-rwxr-xr-x
2023-01-14 16:28
seq
58.92
KB
-rwxr-xr-x
2022-09-20 15:27
setarch
26.58
KB
-rwxr-xr-x
2024-11-21 20:01
setpci
30.31
KB
-rwxr-xr-x
2023-01-17 23:50
setpriv
78.31
KB
-rwxr-xr-x
2024-11-21 20:01
setsid
14.3
KB
-rwxr-xr-x
2024-11-21 20:01
setterm
46.31
KB
-rwxr-xr-x
2024-11-21 20:01
sftp
282.59
KB
-rwxr-xr-x
2026-05-05 10:26
sg
47.75
KB
-rwsr-xr-x
2025-12-14 14:00
sh
122.7
KB
-rwxr-xr-x
2023-01-05 13:20
sha1sum
54.95
KB
-rwxr-xr-x
2022-09-20 15:27
sha224sum
58.95
KB
-rwxr-xr-x
2022-09-20 15:27
sha256sum
58.95
KB
-rwxr-xr-x
2022-09-20 15:27
sha384sum
62.95
KB
-rwxr-xr-x
2022-09-20 15:27
sha512sum
62.95
KB
-rwxr-xr-x
2022-09-20 15:27
shasum
9.75
KB
-rwxr-xr-x
2025-08-29 12:09
shred
63.14
KB
-rwxr-xr-x
2022-09-20 15:27
shuf
58.98
KB
-rwxr-xr-x
2022-09-20 15:27
sieve
31.98
KB
-rwxr-xr-x
2023-03-03 16:00
skill
30.33
KB
-rwxr-xr-x
2022-12-19 06:06
slabtop
22.37
KB
-rwxr-xr-x
2022-12-19 06:06
sleep
42.86
KB
-rwxr-xr-x
2022-09-20 15:27
slogin
1.08
MB
-rwxr-xr-x
2026-05-05 10:26
snap
14.79
MB
-rwxr-xr-x
2026-05-10 10:28
snap-hmm
56
B
-rwxr-xr-x
2020-08-18 08:47
snapctl
5.81
MB
-rwxr-xr-x
2026-05-10 10:28
snice
30.33
KB
-rwxr-xr-x
2022-12-19 06:06
socat
401.98
KB
-rwxr-xr-x
2022-11-06 08:15
soelim
50.43
KB
-rwxr-xr-x
2023-03-07 09:38
sort
115.68
KB
-rwxr-xr-x
2022-09-20 15:27
splain
18.99
KB
-rwxr-xr-x
2025-08-29 12:09
split
59.55
KB
-rwxr-xr-x
2022-09-20 15:27
sqfscat
141.37
KB
-rwxr-xr-x
2022-03-27 16:50
sqfstar
263.9
KB
-rwxr-xr-x
2022-03-27 16:50
ss
189.14
KB
-rwxr-xr-x
2023-05-22 13:19
ssh
1.08
MB
-rwxr-xr-x
2026-05-05 10:26
ssh-add
518.44
KB
-rwxr-xr-x
2026-05-05 10:26
ssh-agent
474.38
KB
-rwxr-sr-x
2026-05-05 10:26
ssh-argv0
1.42
KB
-rwxr-xr-x
2026-05-05 10:26
ssh-copy-id
12.38
KB
-rwxr-xr-x
2023-02-02 12:21
ssh-import-id
409
B
-rwxr-xr-x
2020-03-08 23:48
ssh-import-id-gh
785
B
-rwxr-xr-x
2020-02-28 15:44
ssh-import-id-lp
785
B
-rwxr-xr-x
2020-02-28 15:44
ssh-keygen
646.44
KB
-rwxr-xr-x
2026-05-05 10:26
ssh-keyscan
622.47
KB
-rwxr-xr-x
2026-05-05 10:26
stat
95.2
KB
-rwxr-xr-x
2022-09-20 15:27
stdbuf
58.92
KB
-rwxr-xr-x
2022-09-20 15:27
streamzip
7.75
KB
-rwxr-xr-x
2025-08-29 12:09
stty
83.02
KB
-rwxr-xr-x
2022-09-20 15:27
su
70.31
KB
-rwsr-xr-x
2024-11-21 20:01
sudo
275.02
KB
-rwsr-xr-x
2026-04-11 12:01
sudoedit
275.02
KB
-rwsr-xr-x
2026-04-11 12:01
sudoreplay
115.7
KB
-rwxr-xr-x
2026-04-11 12:01
sum
50.96
KB
-rwxr-xr-x
2022-09-20 15:27
sync
38.89
KB
-rwxr-xr-x
2022-09-20 15:27
systemctl
1.29
MB
-rwxr-xr-x
2026-04-27 19:48
systemd
90.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-analyze
182.61
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-ask-password
18.48
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-cat
18.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-cgls
22.48
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-cgtop
38.4
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-creds
42.61
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-cryptenroll
58.6
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-delta
26.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-detect-virt
18.37
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-escape
18.37
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-firstboot
50.59
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-hwdb
126.66
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-id128
22.37
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-inhibit
22.39
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-machine-id-setup
18.48
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-mount
50.59
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-notify
18.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-path
18.37
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-repart
150.69
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-run
58.57
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-socket-activate
26.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-stdio-bridge
18.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-sysext
42.49
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-sysusers
62.68
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-tmpfiles
110.57
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-tty-ask-password-agent
34.38
KB
-rwxr-xr-x
2026-04-27 19:48
systemd-umount
50.59
KB
-rwxr-xr-x
2026-04-27 19:48
tabs
18.23
KB
-rwxr-xr-x
2023-05-07 14:33
tac
111.05
KB
-rwxr-xr-x
2022-09-20 15:27
tail
75.14
KB
-rwxr-xr-x
2022-09-20 15:27
tar
519.52
KB
-rwxr-xr-x
2024-01-20 09:27
taskset
62.31
KB
-rwxr-xr-x
2024-11-21 20:01
tbl
146.43
KB
-rwxr-xr-x
2023-03-07 09:38
tcpdump
1.21
MB
-rwxr-xr-x
2023-01-14 17:23
tee
42.95
KB
-rwxr-xr-x
2022-09-20 15:27
tempfile
14.18
KB
-rwxr-xr-x
2023-07-28 23:46
test
58.89
KB
-rwxr-xr-x
2022-09-20 15:27
tic
90.34
KB
-rwxr-xr-x
2023-05-07 14:33
timedatectl
42.37
KB
-rwxr-xr-x
2026-04-27 19:48
timeout
47.49
KB
-rwxr-xr-x
2022-09-20 15:27
tload
18.32
KB
-rwxr-xr-x
2022-12-19 06:06
toe
22.23
KB
-rwxr-xr-x
2023-05-07 14:33
top
131.58
KB
-rwxr-xr-x
2022-12-19 06:06
touch
107.05
KB
-rwxr-xr-x
2022-09-20 15:27
tput
26.27
KB
-rwxr-xr-x
2023-05-07 14:33
tr
54.89
KB
-rwxr-xr-x
2022-09-20 15:27
traceproto
2.82
KB
-rwxr-xr-x
2023-02-25 12:24
traceproto.db
2.82
KB
-rwxr-xr-x
2023-02-25 12:24
traceroute
71.23
KB
-rwxr-xr-x
2023-02-25 12:24
traceroute-nanog
1.58
KB
-rwxr-xr-x
2023-02-25 12:24
traceroute.db
71.23
KB
-rwxr-xr-x
2023-02-25 12:24
traceroute6
71.23
KB
-rwxr-xr-x
2023-02-25 12:24
traceroute6.db
71.23
KB
-rwxr-xr-x
2023-02-25 12:24
troff
755.83
KB
-rwxr-xr-x
2023-03-07 09:38
true
34.83
KB
-rwxr-xr-x
2022-09-20 15:27
truncate
42.89
KB
-rwxr-xr-x
2022-09-20 15:27
tset
30.24
KB
-rwxr-xr-x
2023-05-07 14:33
tsort
54.89
KB
-rwxr-xr-x
2022-09-20 15:27
tty
34.86
KB
-rwxr-xr-x
2022-09-20 15:27
tzselect
14.99
KB
-rwxr-xr-x
2026-04-27 20:14
ubuntu-cloudimg-query
8.37
KB
-rwxr-xr-x
2022-06-03 10:51
ubuntu-core-launcher
112.1
KB
-rwsr-xr-x
2026-05-10 10:28
ucf
40.69
KB
-rwxr-xr-x
2024-12-20 07:39
ucfq
18.91
KB
-rwxr-xr-x
2024-12-20 07:39
ucfr
10.85
KB
-rwxr-xr-x
2024-12-20 07:39
uclampset
62.31
KB
-rwxr-xr-x
2024-11-21 20:01
udevadm
1.29
MB
-rwxr-xr-x
2026-04-27 19:48
ul
22.31
KB
-rwxr-xr-x
2024-11-21 20:01
umount
34.3
KB
-rwsr-xr-x
2024-11-21 20:01
uname
42.86
KB
-rwxr-xr-x
2022-09-20 15:27
unattended-upgrade
97.21
KB
-rwxr-xr-x
2022-12-31 20:59
unattended-upgrades
97.21
KB
-rwxr-xr-x
2022-12-31 20:59
uncompress
2.29
KB
-rwxr-xr-x
2022-04-10 02:22
unexpand
42.92
KB
-rwxr-xr-x
2022-09-20 15:27
uniq
46.95
KB
-rwxr-xr-x
2022-09-20 15:27
unlink
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
unlzma
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
unmkinitramfs
3.59
KB
-rwxr-xr-x
2025-04-24 15:40
unshare
82.54
KB
-rwxr-xr-x
2024-11-21 20:01
unsquashfs
141.37
KB
-rwxr-xr-x
2022-03-27 16:50
unxz
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
unzip
175.05
KB
-rwxr-xr-x
2026-08-16 13:50
unzipsfx
82.86
KB
-rwxr-xr-x
2026-08-16 13:50
unzstd
1.22
MB
-rwxr-xr-x
2023-03-18 20:58
update-alternatives
58.31
KB
-rwxr-xr-x
2026-03-07 12:15
update-mime-database
59.27
KB
-rwxr-xr-x
2022-04-29 17:19
uptime
14.3
KB
-rwxr-xr-x
2022-12-19 06:06
users
38.89
KB
-rwxr-xr-x
2022-09-20 15:27
utmpdump
30.3
KB
-rwxr-xr-x
2024-11-21 20:01
uuidgen
18.3
KB
-rwxr-xr-x
2024-11-21 20:01
uuidparse
42.31
KB
-rwxr-xr-x
2024-11-21 20:01
vcs-run
6.75
KB
-rwxr-xr-x
2022-06-03 10:51
vdir
147.8
KB
-rwxr-xr-x
2022-09-20 15:27
vi
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
view
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
vim
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
vim.basic
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
vim.tiny
1.55
MB
-rwxr-xr-x
2025-02-16 05:23
vimdiff
3.48
MB
-rwxr-xr-x
2025-02-16 05:23
vimtutor
2.1
KB
-rwxr-xr-x
2025-02-16 05:23
vmstat
34.72
KB
-rwxr-xr-x
2022-12-19 06:06
w
22.3
KB
-rwxr-xr-x
2022-12-19 06:06
wall
38.3
KB
-rwxr-xr-x
2024-11-21 20:01
watch
26.71
KB
-rwxr-xr-x
2022-12-19 06:06
watchgnupg
18.23
KB
-rwxr-xr-x
2026-01-01 14:54
wc
51.05
KB
-rwxr-xr-x
2022-09-20 15:27
wdctl
70.34
KB
-rwxr-xr-x
2024-11-21 20:01
webmin
13.29
KB
-rwxr-xr-x
2026-07-17 21:17
wget
459.36
KB
-rwxr-xr-x
2025-03-03 13:32
whatis
51.29
KB
-rwxr-xr-x
2023-03-12 22:23
whereis
30.77
KB
-rwxr-xr-x
2024-11-21 20:01
which
946
B
-rwxr-xr-x
2023-07-28 23:46
which.debianutils
946
B
-rwxr-xr-x
2023-07-28 23:46
whiptail
26.75
KB
-rwxr-xr-x
2023-01-31 14:53
who
59.02
KB
-rwxr-xr-x
2022-09-20 15:27
whoami
38.86
KB
-rwxr-xr-x
2022-09-20 15:27
write
22.31
KB
-rwxr-xr-x
2024-11-21 20:01
write-mime-multipart
3.54
KB
-rwxr-xr-x
2022-06-03 10:51
wsrep_sst_backup
2.39
KB
-rwxr-xr-x
2026-06-27 11:11
wsrep_sst_common
67.46
KB
-rwxr-xr-x
2026-06-27 11:11
wsrep_sst_mariabackup
49.28
KB
-rwxr-xr-x
2026-06-27 11:11
wsrep_sst_mysqldump
8.11
KB
-rwxr-xr-x
2026-06-27 11:11
wsrep_sst_rsync
29.92
KB
-rwxr-xr-x
2026-06-27 11:11
wsrep_sst_rsync_wan
29.92
KB
-rwxr-xr-x
2026-06-27 11:11
www-browser
1.86
MB
-rwxr-xr-x
2023-01-15 14:21
x86_64
26.58
KB
-rwxr-xr-x
2024-11-21 20:01
xargs
70.45
KB
-rwxr-xr-x
2023-01-08 18:07
xsubpp
5.05
KB
-rwxr-xr-x
2025-08-29 12:09
xz
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
xzcat
82.7
KB
-rwxr-xr-x
2026-06-26 13:13
xzcmp
7.25
KB
-rwxr-xr-x
2026-06-26 13:13
xzdiff
7.25
KB
-rwxr-xr-x
2026-06-26 13:13
xzegrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
xzfgrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
xzgrep
10.09
KB
-rwxr-xr-x
2026-06-26 13:13
xzless
1.77
KB
-rwxr-xr-x
2026-06-26 13:13
xzmore
2.14
KB
-rwxr-xr-x
2026-06-26 13:13
yes
38.83
KB
-rwxr-xr-x
2022-09-20 15:27
ypdomainname
22.15
KB
-rwxr-xr-x
2022-12-19 13:33
zcat
1.94
KB
-rwxr-xr-x
2022-04-10 02:22
zcmp
1.64
KB
-rwxr-xr-x
2022-04-10 02:22
zdiff
6.31
KB
-rwxr-xr-x
2022-04-10 02:22
zdump
22.52
KB
-rwxr-xr-x
2026-04-27 20:14
zegrep
29
B
-rwxr-xr-x
2022-04-10 02:22
zff2gff3.pl
684
B
-rwxr-xr-x
2013-11-30 07:54
zfgrep
29
B
-rwxr-xr-x
2022-04-10 02:22
zforce
2.03
KB
-rwxr-xr-x
2022-04-10 02:22
zgrep
7.91
KB
-rwxr-xr-x
2022-04-10 02:22
zipdetails
68.55
KB
-rwxr-xr-x
2025-08-29 12:09
zipgrep
2.89
KB
-rwxr-xr-x
2026-08-16 13:50
zipinfo
175.05
KB
-rwxr-xr-x
2026-08-16 13:50
zless
2.15
KB
-rwxr-xr-x
2022-04-10 02:22
zmore
1.8
KB
-rwxr-xr-x
2022-04-10 02:22
znew
4.47
KB
-rwxr-xr-x
2022-04-10 02:22
zoe-loop
126.62
KB
-rwxr-xr-x
2020-12-22 13:24
zstd
1.22
MB
-rwxr-xr-x
2023-03-18 20:58
zstdcat
1.22
MB
-rwxr-xr-x
2023-03-18 20:58
zstdgrep
3.78
KB
-rwxr-xr-x
2023-03-18 20:58
zstdless
197
B
-rwxr-xr-x
2023-03-18 20:58
zstdmt
1.22
MB
-rwxr-xr-x
2023-03-18 20:58
Save
Rename
#!/bin/bash VERBOSITY=0 TEMP_D="" UMOUNTS=( ) QEMU_DISCONNECT="" CR=$'\n' TAB=$'\t' error() { echo "$@" 1>&2; } Usage() { cat <<EOF Usage: ${0##*/} [ options ] file cmd [ args ] mount a file to a temporary mount point and then invoke the provided cmd with args supported 'file' are: file : any disk format supported by qemu-nbd the temporary mountpoint will be put in an a environment variable named MOUNTPOINT. if any of the arguments are the literal string '_MOUNTPOINT_', then they will be replaced with the mount point. Example: ${0##*/} my.img chroot _MOUNTPOINT_ /bin/sh Additionally, the helper program 'mchroot' will be added to the path and can be used effectively as 'chroot _MOUNTPOINT_': ${0##*/} my.img mchroot options: -v | --verbose increase verbosity -h | --help print this message. --read-only use read-only mount. -C | --cd-mountpoint change dir to mountpoint before executing cmd. -m | --mountpoint MP mount to directory MP rather than a temp dir --overlay mount via overlayfs -P | --partition PARTNUM mount partition PARTNUM (default 'auto') if 'auto', then mount part 1 if image is partitioned otherwise mount image -p | --proc bind mount /proc -s | --sys bind mount /sys -d | --dev bind mount /dev --system-mounts bind mount /sys, /proc, /dev --system-resolvconf copy host's resolvconf into /etc/resolvconf --format FMT specify the format of the image. default is to automatically determine EOF } # umount_r(mp) : unmount any filesystems under r # this is useful to unmount a chroot that had sys, proc ... mounted umount_r() { local p for p in "$@"; do [ -n "$p" ] || continue tac /proc/mounts | sh -c ' p=$1 didumount=0 while read s mp t opt a b ; do [ "${mp}" = "${p}" -o "${mp#${p}/}" != "${mp}" ] || continue umount "$mp" || exit 1 didumount=1 done [ $didumount -eq 1 ] || exit 1 exit 0' umount_r "${p%/}" [ $? -eq 0 ] || return done } bad_Usage() { Usage 1>&2; [ $# -eq 0 ] || error "$@"; exit 1; } has_cmd() { command -v "$1" >/dev/null 2>&1 } disconnect_qemu() { [ -n "$QEMU_DISCONNECT" ] || return 0 local out="" nbd="$QEMU_DISCONNECT" debug 1 "disconnecting $nbd" local pid="" pfile="/sys/block/${nbd#/dev/}/pid" { read pid < "$pfile" ; } >/dev/null 2>&1 [ -n "$pid" -a ! -d "/proc/$pid" ] && error "qemu-nbd process seems to have died. was '$pid'" out=$(qemu-nbd --disconnect "$nbd" 2>&1) && QEMU_DISCONNECT="" || { error "failed to disconnect $nbd"; error "$out" return 1; } } do_umounts() { local um="" fails=0 mydir="$PWD/" mounts="" i=0 mounts=( "$@" ) for((i=${#mounts[@]}-1;i>=0;i--)); do um=${mounts[$i]} um=$(readlink -f "$um") || { error "WARNING: failed to get full path to '$um'"; fails=$(($fails+1)) continue; } [ "${mydir#${um}/}" != "${mydir}" ] && { error "WARNING: leaving '$mydir' to unmount $um"; cd / } umount_r "$um" || { error "WARNING: unmounting filesystem at $um failed!" fails=$(($fails+1)) } done return $fails } cleanup() { if [ "${#UMOUNTS[@]}" -ne 0 ]; then debug 2 "umounts: ${UMOUNTS[*]}" do_umounts "${UMOUNTS[@]}" || { error "failed cleaning up mounts"; return 1; } fi disconnect_qemu rm -Rf "$TEMP_D" || error "removal of temp dir failed!" } debug() { local level="$1"; shift; [ "${level}" -gt "${VERBOSITY}" ] && return error "${@}" } get_image_format() { local img="$1" out="" out=$(qemu-img info "$img") && out=$(echo "$out" | awk '$0 ~ /^file format:/ { print $3 }') && _RET="$out" } get_partition() { # return in _RET the 'auto' partition for a image. # _RET=partition number for a partitioned image # _RET=0 for unpartitioned local img="$1" out=$(LANG=C sfdisk --list -uS "$img" 2>&1) || { error "failed determining if partitioned: $out"; return 1; } if echo "$out" | grep -q 'Device.*Start.*End'; then _RET=1 else _RET=0 fi } add_bin() { cat > "$1" || { error "failed to write to $1"; return 1; } chmod 755 "$1" || { error "failed to set perms on $1"; return 1; } } add_helpers() { local d="$1" local umap="$1" gmap="$2" [ -d "$1" ] || mkdir -p "$1" add_bin "$d/mchroot" <<"EOF" || return 1 #!/bin/sh exec chroot "$MOUNTPOINT" "$@" EOF return } mount_overlay() { local lower="$1" upper="$2" workdir="$3" local olayopts="lowerdir=$lower,upperdir=$upper" # 3.18+ require 'workdir=' option. case "$(uname -r)" in 2*|3.1[01234567]*|3.[0-9].*) :;; *) olayopts="${olayopts},workdir=$workdir" mkdir -p "$workdir" || { _ERR="Failed to create workdir '$workdir'"; return 1; } ;; esac local cmd="" fstype="" ret="" out="" fsfile="/proc/filesystems" _ERR="" for fstype in overlay overlayfs; do cmd=( mount -t "$fstype" -o "$olayopts" "$lower" "$upper" ) debug 2 "attempting '$fstype' mount with: ${cmd[*]}" out=$("${cmd[@]}" 2>&1) ret=$? if [ $ret -eq 0 ]; then debug 1 "mounted '$fstype' via $fstype: ${cmd[*]}" return 0 fi _ERR="${_ERR}Failed [$ret]: ${cmd[*]}:${CR}" _ERR="${_ERR}$out${CR}" if [ -r "$fsfile" ] && grep -q "${TAB}${fstype}$" "$fsfile"; then # this failed and we have support in kernel. do not try further. return $ret fi done return $ret } assert_nbd_support() { if [ ! -e /sys/block/nbd0 ] && ! grep -q nbd /proc/modules; then debug 1 "trying to load nbd module" modprobe nbd >/dev/null 2>&1 has_cmd udevadm && udevadm settle >/dev/null 2>&1 fi [ -e /sys/block/nbd0 ] || { error "Cannot use nbd: no nbd kernel support." return 1; } } find_unused_nbd() { # return a path to an unused nbd device (/dev/nbd?) local f roflag="" for f in /sys/block/nbd*; do [ -d "$f" -a ! -f "$f/pid" ] && { _RET="/dev/${f##*/}"; return 0; } done error "failed to find an nbd device" return 1; } connect_nbd() { local img="$1" fmt="$2" ptnum="${3:-auto}" rwmode="${3:-ro}" local nbd="" pidfile="" pid="" cmd="" ret="" roflag="" nptnum="" i="" if [ "$rwmode" = "ro" ]; then roflag="--read-only" fi # yes, there is a race condition here. find_unused_nbd || return nbd="$_RET" cmd=( qemu-nbd $roflag "--format=$fmt" --connect "$nbd" "$img" ) "${cmd[@]}" && QEMU_DISCONNECT="$nbd" ret=$? if [ $ret -ne 0 ]; then error "Failed [$ret]: $*" return $ret fi pidfile="/sys/block/${nbd#/dev/}/pid" if [ ! -f "$pidfile" ]; then debug 1 "waiting on pidfile for $nbd in $pidfile" i=0 while [ ! -f "$pidfile" ] && i=$(($i+1)); do if [ $i -eq 200 ]; then error "giving up on pidfile $pidfile for $nbd" disconnect_qemu return 1 fi sleep .1 debug 2 "." done fi read pid < "$pidfile" && debug 2 "pid for $nbd is $pid" || { error "reading pid from $pidfile for $nbd failed!"; disconnect_qemu return 1 } debug 1 "connected $img_in ($fmt) ${rwmode} to $nbd. waiting for device." local out="" # This can fail due to udev events, but we ignore that. We need to ensure # it happens for where it doesnt happen automatically (LP: #1741300) out=$(blockdev --rereadpt "$nbd" 2>&1) || debug 1 "blockdev rereadpt $nbd failed" has_cmd udevadm && udevadm settle i=0 while i=$(($i+1)); do get_partition "$nbd" && nptnum="$_RET" && break [ $i -eq 40 ] && { error "gave up on $nbd" disconnect_qemu return 1 } [ $(($i%10)) -eq 0 ] && debug 1 "waiting for $nbd to be ready." sleep .1 done if [ "${ptnum}" = "auto" ]; then if [ "$nptnum" = "0" ]; then debug 1 "unpartitioned disk." else debug 1 "partitioned disk." fi ptnum=$nptnum else if [ "$nptnum" = "0" -a "$ptnum" != "0" ]; then error "img $img does not appear partitioned but ptnum=$ptnum provided." return 1 fi fi if [ "$ptnum" -ne 0 ]; then mdev="${nbd}p${ptnum}" else mdev="${nbd}" fi i=0 while :; do [ -b "$mdev" ] && break i=$(($i+1)) [ $i -eq 100 ] && { error "gave up on waiting for $mdev" disconnect_qemu return 1 } [ $(($i%10)) -eq 0 ] && debug 1 "waiting for $mdev part=$ptnum to be ready." sleep .1 done _RET_NBD="$nbd" _RET_PT="$ptnum" _RET_DEV="$mdev" } mount_nbd() { local img="$1" mp="$2" fmt="$3" ptnum="$4" rwmode="${5:-rw}" opts="$6" if [ -z "$fmt" ]; then get_image_format "$img" && fmt="$_RET" || { error "failed to get image format for '$img' (try --format)" return 1 } fi assert_nbd_support || return connect_nbd "$img" "$fmt" "$ptnum" "$rwmode" || return local ptnum="$_RET_PT" mdev="$_RET_DEV" nbd="$_RET_NBD" if ( set -f; mount -o "$rwmode" $opts "$mdev" "$img_mp" ); then debug 1 "mounted $mdev via qemu-nbd $nbd at $img_mp" else error "failed to mount $mdev" return 1 fi } mount_callback_umount() { local img_in="$1" dev="" out="" mp="" ret="" img="" readonly=false local opts="" bmounts="" system_resolvconf=false ptnum=auto local cd_mountpoint=false fmt="" overlay=false rwmode="rw" local img_mp="" short_opts="Cdhm:P:psSv" long_opts="cd-mountpoint,dev,help,format:,mountpoint:,overlay,partition:,proc,read-only,sys,system-mounts,system-resolvconf,verbose" getopt_out=$(getopt -n "${0##*/}" \ -o "${short_opts}" -l "${long_opts}" -- "$@") && eval set -- "${getopt_out}" || { bad_Usage; return 1; } while [ $# -ne 0 ]; do cur=${1}; next=${2}; case "$cur" in -C|--cd-mountpoint) cd_mountpoint=true;; -d|--dev) bmounts="${bmounts:+${bmounts} }/dev";; --format) fmt=$next;; -h|--help) Usage ; exit 0;; -m|--mountpoint) mp=$next;; -P|--partition) ptnum=$next;; --overlay) overlay=true;; -p|--proc) bmounts="${bmounts:+${bmounts} }/proc";; -s|--sys) bmounts="${bmounts:+${bmounts} }/sys";; -S|--system-mounts) bmounts="/dev /proc /sys";; --system-resolvconf) system_resolvconf=true;; -v|--verbose) VERBOSITY=$((${VERBOSITY}+1));; --opts) opts="${opts} $next"; shift;; --read-only) readonly=true; rwmode="ro";; --) shift; break;; esac shift; done [ $# -ge 2 ] || { bad_Usage "must provide image and cmd"; return 1; } $readonly && { $system_resolvconf && ! $overlay; } && { error "--read-only is incompatible with system-resolvconf"; error "maybe try with --overlay" return 1; } img_in="$1" shift 1 if [ "${img_in#lxd:}" != "${img_in}" -a ! -f "${img_in}" ]; then error "${img_in}: lxd is no longer supported." return 1; fi img=$(readlink -f "$img_in") || { error "failed to get full path to $img_in"; return 1; } [ -f "$img" ] || { error "$img: not a file"; return 1; } [ "$(id -u)" = "0" ] || { error "sorry, must be root"; return 1; } trap cleanup EXIT TEMP_D=$(mktemp -d "${TMPDIR:-/tmp}/${0##*/}.XXXXXX") || { error "failed to make tempdir"; return 1; } if [ -z "$mp" ]; then mp="${TEMP_D}/mp" mkdir "$mp" || return else [ -d "$mp" ] || { error "mountpoint '$mp': not a directory"; return 1; } mp=$(readlink -f "$mp") || { error "failed to get full path to provided mountpoint"; return 1; } fi if $overlay; then img_mp="${TEMP_D}/underlay" mkdir -p "$img_mp" || return else img_mp=$mp fi out="" if [ "$ptnum" = "auto" -o "$ptnum" = "0" ] && out=$(set -f; mount -o "loop,$rwmode" $opts "$img" "$img_mp" 2>&1); then debug 1 "mounted simple fs image $rwmode in '$img_in' at $img_mp" UMOUNTS[${#UMOUNTS[@]}]="$img_mp" else local hasqemu=false command -v "qemu-nbd" >/dev/null 2>&1 && hasqemu=true if ! $hasqemu; then error "simple mount of '$img_in' failed." error "if this is not a simple unpartitioned raw image, then" error "you must have qemu-nbd (apt-get install qemu-utils)" if [ -n "$out" ]; then error "mount failed with: $out" fi return 1 fi mount_nbd "$img" "$img_mp" "$fmt" "$ptnum" "$rwmode" "$opts" || return UMOUNTS[${#UMOUNTS[@]}]="$img_mp" fi if $overlay; then mount_overlay "$img_mp" "$mp" "${TEMP_D}/workdir" || { [ -n "${_ERR}" ] && error "${_ERR}" error "Unable to mount overlay filesystem. Maybe no kernel support?" return 1 } UMOUNTS[${#UMOUNTS[@]}]="$mp" fi local bindmp="" for bindmp in $bmounts; do [ -d "$mp${bindmp}" ] || mkdir "$mp${bindmp}" || { error "failed mkdir $bindmp in mount"; return 1; } mount --bind "$bindmp" "$mp${bindmp}" || { error "failed bind mount '$bindmp'"; return 1; } UMOUNTS[${#UMOUNTS[@]}]="$mp${bindmp}" debug 1 "mounted $bindmp to $mp${bindmp}" done if ${system_resolvconf}; then local rcf="$mp/etc/resolv.conf" debug 1 "replacing /etc/resolvconf" if [ -e "$rcf" -o -L "$rcf" ]; then local trcf="$rcf.${0##*/}.$$" rm -f "$trcf" && mv "$rcf" "$trcf" && ORIG_RESOLVCONF="$trcf" || { error "failed mv $rcf"; return 1; } fi cp "/etc/resolv.conf" "$rcf" || { error "failed copy /etc/resolv.conf"; return 1; } fi local cmd="" arg="" found=false cmd=( ) for arg in "$@"; do if [ "${arg}" = "_MOUNTPOINT_" ]; then debug 1 "replaced string _MOUNTPOINT_ in arguments arg ${#cmd[@]}" arg=$mp fi cmd[${#cmd[@]}]="$arg" done if [ "${cmd[0]##*/}" = "bash" -o "${cmd[0]##*/}" = "sh" ] && [ ${#cmd[@]} -eq 0 ]; then debug 1 "invoking shell ${cmd[0]}" error "MOUNTPOINT=$mp" fi add_helpers "$TEMP_D/bin" "$SUBUID" "$SUBGID" || { error "failed to add helpers to $TEMP_D"; return 1; } PATH="$TEMP_D/bin:$PATH" local startwd="$PWD" debug 1 "invoking: MOUNTPOINT=$mp" "${cmd[@]}" ${cd_mountpoint} && cd "$mp" MOUNTPOINT="$mp" "${cmd[@]}" ret=$? cd "$startwd" if ${system_resolvconf}; then local rcf="$mp/etc/resolv.conf" cmp -s "/etc/resolv.conf" "$rcf" >/dev/null || error "WARN: /etc/resolv.conf changed in image!" rm "$rcf" && { [ -z "$ORIG_RESOLVCONF" ] || mv "$ORIG_RESOLVCONF" "$rcf"; } || { error "failed to restore /etc/resolv.conf"; return 1; } fi debug 1 "cmd returned $ret. unmounting $mp" do_umounts "${UMOUNTS[@]}" && UMOUNTS=( ) || { error "failed umount $img"; return 1; } if [ -n "$QEMU_DISCONNECT" ]; then disconnect_qemu || return 1; fi return $ret } mount_callback_umount "$@" # vi: ts=4 noexpandtab